package com.me.brickbuster.layout;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.utils.Json;
import com.me.brickbuster.state.FieldState;
import com.me.brickbuster.state.PlayState;

public class FileLevelLoader implements LevelLoader {

	private static final Json JSON = new Json();

	private FieldState state;
	private int level = 1;

	public FileLevelLoader(FieldState state) {
		this.state = state;
	}

	@Override
	public Level getNextLevel() {
		FileHandle file = Gdx.files.internal("levels/level_" + level + ".json");
		if (file.exists()) {
			LevelJsonTemplate template = JSON.fromJson(LevelJsonTemplate.class, file);

			Texture background = null;
			if (template.backgroundFile != null && !"".equals(template.backgroundFile)) {
				background = new Texture(Gdx.files.internal(template.backgroundFile));
			}

			level++;
			return new Level(new FileLayout(state, template), background, template.randomPowerUpChance);
		}
		return null;
	}

}
