package com.me.brickbuster.physics;

import com.badlogic.gdx.physics.box2d.Contact;
import com.badlogic.gdx.physics.box2d.ContactImpulse;
import com.badlogic.gdx.physics.box2d.ContactListener;
import com.badlogic.gdx.physics.box2d.Manifold;
import com.me.brickbuster.entity.Entity;

public class Box2dContactListener implements ContactListener {

	@Override
	public void beginContact(Contact contact) {
		Object userDataA = contact.getFixtureA().getBody().getUserData();
		Object userDataB = contact.getFixtureB().getBody().getUserData();

		if (userDataA == null || userDataB == null ||
				!(userDataA instanceof Entity) || !(userDataB instanceof Entity)) {
			return;
		}

		if (userDataA instanceof CollisionListener) {
			((CollisionListener) userDataA).beginContact((Entity) userDataB);
		}
		if (userDataB instanceof CollisionListener) {
			((CollisionListener) userDataB).beginContact((Entity) userDataA);
		}
	}

	@Override
	public void endContact(Contact contact) {
		Object userDataA = contact.getFixtureA().getBody().getUserData();
		Object userDataB = contact.getFixtureB().getBody().getUserData();

		if (userDataA == null || userDataB == null ||
				!(userDataA instanceof Entity) || !(userDataB instanceof Entity)) {
			return;
		}

		if (userDataA instanceof CollisionListener) {
			((CollisionListener) userDataA).endContact((Entity) userDataB);
		}
		if (userDataB instanceof CollisionListener) {
			((CollisionListener) userDataB).endContact((Entity) userDataA);
		}
	}

	@Override
	public void preSolve(Contact contact, Manifold oldManifold) {}

	@Override
	public void postSolve(Contact contact, ContactImpulse impulse) {}

}
